//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: confio/poe/v1beta1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query defines the gRPC querier service.
///
/// Usage: instantiate `Confio_Poe_V1beta1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Confio_Poe_V1beta1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Confio_Poe_V1beta1_QueryClientInterceptorFactoryProtocol? { get }

  func contractAddress(
    _ request: Confio_Poe_V1beta1_QueryContractAddressRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Confio_Poe_V1beta1_QueryContractAddressRequest, Confio_Poe_V1beta1_QueryContractAddressResponse>

  func validators(
    _ request: Cosmos_Staking_V1beta1_QueryValidatorsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Staking_V1beta1_QueryValidatorsRequest, Cosmos_Staking_V1beta1_QueryValidatorsResponse>

  func validator(
    _ request: Cosmos_Staking_V1beta1_QueryValidatorRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Staking_V1beta1_QueryValidatorRequest, Cosmos_Staking_V1beta1_QueryValidatorResponse>

  func unbondingPeriod(
    _ request: Confio_Poe_V1beta1_QueryUnbondingPeriodRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Confio_Poe_V1beta1_QueryUnbondingPeriodRequest, Confio_Poe_V1beta1_QueryUnbondingPeriodResponse>

  func validatorDelegation(
    _ request: Confio_Poe_V1beta1_QueryValidatorDelegationRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Confio_Poe_V1beta1_QueryValidatorDelegationRequest, Confio_Poe_V1beta1_QueryValidatorDelegationResponse>

  func validatorUnbondingDelegations(
    _ request: Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsRequest, Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsResponse>

  func historicalInfo(
    _ request: Cosmos_Staking_V1beta1_QueryHistoricalInfoRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Staking_V1beta1_QueryHistoricalInfoRequest, Cosmos_Staking_V1beta1_QueryHistoricalInfoResponse>

  func validatorOutstandingReward(
    _ request: Confio_Poe_V1beta1_QueryValidatorOutstandingRewardRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Confio_Poe_V1beta1_QueryValidatorOutstandingRewardRequest, Confio_Poe_V1beta1_QueryValidatorOutstandingRewardResponse>
}

extension Confio_Poe_V1beta1_QueryClientProtocol {
  internal var serviceName: String {
    return "confio.poe.v1beta1.Query"
  }

  /// ContractAddress queries the address for one of the PoE contracts
  ///
  /// - Parameters:
  ///   - request: Request to send to ContractAddress.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func contractAddress(
    _ request: Confio_Poe_V1beta1_QueryContractAddressRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Confio_Poe_V1beta1_QueryContractAddressRequest, Confio_Poe_V1beta1_QueryContractAddressResponse> {
    return self.makeUnaryCall(
      path: "/confio.poe.v1beta1.Query/ContractAddress",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeContractAddressInterceptors() ?? []
    )
  }

  /// Validators queries all validators that match the given status.
  ///
  /// - Parameters:
  ///   - request: Request to send to Validators.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func validators(
    _ request: Cosmos_Staking_V1beta1_QueryValidatorsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Staking_V1beta1_QueryValidatorsRequest, Cosmos_Staking_V1beta1_QueryValidatorsResponse> {
    return self.makeUnaryCall(
      path: "/confio.poe.v1beta1.Query/Validators",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeValidatorsInterceptors() ?? []
    )
  }

  /// Validator queries validator info for given validator address.
  ///
  /// - Parameters:
  ///   - request: Request to send to Validator.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func validator(
    _ request: Cosmos_Staking_V1beta1_QueryValidatorRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Staking_V1beta1_QueryValidatorRequest, Cosmos_Staking_V1beta1_QueryValidatorResponse> {
    return self.makeUnaryCall(
      path: "/confio.poe.v1beta1.Query/Validator",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeValidatorInterceptors() ?? []
    )
  }

  /// Validator queries validator info for given validator address.
  ///
  /// - Parameters:
  ///   - request: Request to send to UnbondingPeriod.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func unbondingPeriod(
    _ request: Confio_Poe_V1beta1_QueryUnbondingPeriodRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Confio_Poe_V1beta1_QueryUnbondingPeriodRequest, Confio_Poe_V1beta1_QueryUnbondingPeriodResponse> {
    return self.makeUnaryCall(
      path: "/confio.poe.v1beta1.Query/UnbondingPeriod",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeUnbondingPeriodInterceptors() ?? []
    )
  }

  /// ValidatorDelegation queries self delegated amount for given validator.
  ///
  /// - Parameters:
  ///   - request: Request to send to ValidatorDelegation.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func validatorDelegation(
    _ request: Confio_Poe_V1beta1_QueryValidatorDelegationRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Confio_Poe_V1beta1_QueryValidatorDelegationRequest, Confio_Poe_V1beta1_QueryValidatorDelegationResponse> {
    return self.makeUnaryCall(
      path: "/confio.poe.v1beta1.Query/ValidatorDelegation",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeValidatorDelegationInterceptors() ?? []
    )
  }

  /// ValidatorUnbondingDelegations queries unbonding delegations of a validator.
  ///
  /// - Parameters:
  ///   - request: Request to send to ValidatorUnbondingDelegations.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func validatorUnbondingDelegations(
    _ request: Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsRequest, Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsResponse> {
    return self.makeUnaryCall(
      path: "/confio.poe.v1beta1.Query/ValidatorUnbondingDelegations",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeValidatorUnbondingDelegationsInterceptors() ?? []
    )
  }

  /// HistoricalInfo queries the historical info for given height.
  ///
  /// - Parameters:
  ///   - request: Request to send to HistoricalInfo.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func historicalInfo(
    _ request: Cosmos_Staking_V1beta1_QueryHistoricalInfoRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Staking_V1beta1_QueryHistoricalInfoRequest, Cosmos_Staking_V1beta1_QueryHistoricalInfoResponse> {
    return self.makeUnaryCall(
      path: "/confio.poe.v1beta1.Query/HistoricalInfo",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeHistoricalInfoInterceptors() ?? []
    )
  }

  /// ValidatorOutstandingRewards queries rewards of a validator address.
  ///
  /// - Parameters:
  ///   - request: Request to send to ValidatorOutstandingReward.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func validatorOutstandingReward(
    _ request: Confio_Poe_V1beta1_QueryValidatorOutstandingRewardRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Confio_Poe_V1beta1_QueryValidatorOutstandingRewardRequest, Confio_Poe_V1beta1_QueryValidatorOutstandingRewardResponse> {
    return self.makeUnaryCall(
      path: "/confio.poe.v1beta1.Query/ValidatorOutstandingReward",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeValidatorOutstandingRewardInterceptors() ?? []
    )
  }
}

internal protocol Confio_Poe_V1beta1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'contractAddress'.
  func makeContractAddressInterceptors() -> [ClientInterceptor<Confio_Poe_V1beta1_QueryContractAddressRequest, Confio_Poe_V1beta1_QueryContractAddressResponse>]

  /// - Returns: Interceptors to use when invoking 'validators'.
  func makeValidatorsInterceptors() -> [ClientInterceptor<Cosmos_Staking_V1beta1_QueryValidatorsRequest, Cosmos_Staking_V1beta1_QueryValidatorsResponse>]

  /// - Returns: Interceptors to use when invoking 'validator'.
  func makeValidatorInterceptors() -> [ClientInterceptor<Cosmos_Staking_V1beta1_QueryValidatorRequest, Cosmos_Staking_V1beta1_QueryValidatorResponse>]

  /// - Returns: Interceptors to use when invoking 'unbondingPeriod'.
  func makeUnbondingPeriodInterceptors() -> [ClientInterceptor<Confio_Poe_V1beta1_QueryUnbondingPeriodRequest, Confio_Poe_V1beta1_QueryUnbondingPeriodResponse>]

  /// - Returns: Interceptors to use when invoking 'validatorDelegation'.
  func makeValidatorDelegationInterceptors() -> [ClientInterceptor<Confio_Poe_V1beta1_QueryValidatorDelegationRequest, Confio_Poe_V1beta1_QueryValidatorDelegationResponse>]

  /// - Returns: Interceptors to use when invoking 'validatorUnbondingDelegations'.
  func makeValidatorUnbondingDelegationsInterceptors() -> [ClientInterceptor<Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsRequest, Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsResponse>]

  /// - Returns: Interceptors to use when invoking 'historicalInfo'.
  func makeHistoricalInfoInterceptors() -> [ClientInterceptor<Cosmos_Staking_V1beta1_QueryHistoricalInfoRequest, Cosmos_Staking_V1beta1_QueryHistoricalInfoResponse>]

  /// - Returns: Interceptors to use when invoking 'validatorOutstandingReward'.
  func makeValidatorOutstandingRewardInterceptors() -> [ClientInterceptor<Confio_Poe_V1beta1_QueryValidatorOutstandingRewardRequest, Confio_Poe_V1beta1_QueryValidatorOutstandingRewardResponse>]
}

internal final class Confio_Poe_V1beta1_QueryClient: Confio_Poe_V1beta1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Confio_Poe_V1beta1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the confio.poe.v1beta1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Confio_Poe_V1beta1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query defines the gRPC querier service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Confio_Poe_V1beta1_QueryProvider: CallHandlerProvider {
  var interceptors: Confio_Poe_V1beta1_QueryServerInterceptorFactoryProtocol? { get }

  /// ContractAddress queries the address for one of the PoE contracts
  func contractAddress(request: Confio_Poe_V1beta1_QueryContractAddressRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Confio_Poe_V1beta1_QueryContractAddressResponse>

  /// Validators queries all validators that match the given status.
  func validators(request: Cosmos_Staking_V1beta1_QueryValidatorsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Staking_V1beta1_QueryValidatorsResponse>

  /// Validator queries validator info for given validator address.
  func validator(request: Cosmos_Staking_V1beta1_QueryValidatorRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Staking_V1beta1_QueryValidatorResponse>

  /// Validator queries validator info for given validator address.
  func unbondingPeriod(request: Confio_Poe_V1beta1_QueryUnbondingPeriodRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Confio_Poe_V1beta1_QueryUnbondingPeriodResponse>

  /// ValidatorDelegation queries self delegated amount for given validator.
  func validatorDelegation(request: Confio_Poe_V1beta1_QueryValidatorDelegationRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Confio_Poe_V1beta1_QueryValidatorDelegationResponse>

  /// ValidatorUnbondingDelegations queries unbonding delegations of a validator.
  func validatorUnbondingDelegations(request: Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsResponse>

  /// HistoricalInfo queries the historical info for given height.
  func historicalInfo(request: Cosmos_Staking_V1beta1_QueryHistoricalInfoRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Staking_V1beta1_QueryHistoricalInfoResponse>

  /// ValidatorOutstandingRewards queries rewards of a validator address.
  func validatorOutstandingReward(request: Confio_Poe_V1beta1_QueryValidatorOutstandingRewardRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Confio_Poe_V1beta1_QueryValidatorOutstandingRewardResponse>
}

extension Confio_Poe_V1beta1_QueryProvider {
  internal var serviceName: Substring { return "confio.poe.v1beta1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "ContractAddress":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Confio_Poe_V1beta1_QueryContractAddressRequest>(),
        responseSerializer: ProtobufSerializer<Confio_Poe_V1beta1_QueryContractAddressResponse>(),
        interceptors: self.interceptors?.makeContractAddressInterceptors() ?? [],
        userFunction: self.contractAddress(request:context:)
      )

    case "Validators":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Staking_V1beta1_QueryValidatorsRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Staking_V1beta1_QueryValidatorsResponse>(),
        interceptors: self.interceptors?.makeValidatorsInterceptors() ?? [],
        userFunction: self.validators(request:context:)
      )

    case "Validator":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Staking_V1beta1_QueryValidatorRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Staking_V1beta1_QueryValidatorResponse>(),
        interceptors: self.interceptors?.makeValidatorInterceptors() ?? [],
        userFunction: self.validator(request:context:)
      )

    case "UnbondingPeriod":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Confio_Poe_V1beta1_QueryUnbondingPeriodRequest>(),
        responseSerializer: ProtobufSerializer<Confio_Poe_V1beta1_QueryUnbondingPeriodResponse>(),
        interceptors: self.interceptors?.makeUnbondingPeriodInterceptors() ?? [],
        userFunction: self.unbondingPeriod(request:context:)
      )

    case "ValidatorDelegation":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Confio_Poe_V1beta1_QueryValidatorDelegationRequest>(),
        responseSerializer: ProtobufSerializer<Confio_Poe_V1beta1_QueryValidatorDelegationResponse>(),
        interceptors: self.interceptors?.makeValidatorDelegationInterceptors() ?? [],
        userFunction: self.validatorDelegation(request:context:)
      )

    case "ValidatorUnbondingDelegations":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsRequest>(),
        responseSerializer: ProtobufSerializer<Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsResponse>(),
        interceptors: self.interceptors?.makeValidatorUnbondingDelegationsInterceptors() ?? [],
        userFunction: self.validatorUnbondingDelegations(request:context:)
      )

    case "HistoricalInfo":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Staking_V1beta1_QueryHistoricalInfoRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Staking_V1beta1_QueryHistoricalInfoResponse>(),
        interceptors: self.interceptors?.makeHistoricalInfoInterceptors() ?? [],
        userFunction: self.historicalInfo(request:context:)
      )

    case "ValidatorOutstandingReward":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Confio_Poe_V1beta1_QueryValidatorOutstandingRewardRequest>(),
        responseSerializer: ProtobufSerializer<Confio_Poe_V1beta1_QueryValidatorOutstandingRewardResponse>(),
        interceptors: self.interceptors?.makeValidatorOutstandingRewardInterceptors() ?? [],
        userFunction: self.validatorOutstandingReward(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Confio_Poe_V1beta1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'contractAddress'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeContractAddressInterceptors() -> [ServerInterceptor<Confio_Poe_V1beta1_QueryContractAddressRequest, Confio_Poe_V1beta1_QueryContractAddressResponse>]

  /// - Returns: Interceptors to use when handling 'validators'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeValidatorsInterceptors() -> [ServerInterceptor<Cosmos_Staking_V1beta1_QueryValidatorsRequest, Cosmos_Staking_V1beta1_QueryValidatorsResponse>]

  /// - Returns: Interceptors to use when handling 'validator'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeValidatorInterceptors() -> [ServerInterceptor<Cosmos_Staking_V1beta1_QueryValidatorRequest, Cosmos_Staking_V1beta1_QueryValidatorResponse>]

  /// - Returns: Interceptors to use when handling 'unbondingPeriod'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeUnbondingPeriodInterceptors() -> [ServerInterceptor<Confio_Poe_V1beta1_QueryUnbondingPeriodRequest, Confio_Poe_V1beta1_QueryUnbondingPeriodResponse>]

  /// - Returns: Interceptors to use when handling 'validatorDelegation'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeValidatorDelegationInterceptors() -> [ServerInterceptor<Confio_Poe_V1beta1_QueryValidatorDelegationRequest, Confio_Poe_V1beta1_QueryValidatorDelegationResponse>]

  /// - Returns: Interceptors to use when handling 'validatorUnbondingDelegations'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeValidatorUnbondingDelegationsInterceptors() -> [ServerInterceptor<Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsRequest, Confio_Poe_V1beta1_QueryValidatorUnbondingDelegationsResponse>]

  /// - Returns: Interceptors to use when handling 'historicalInfo'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeHistoricalInfoInterceptors() -> [ServerInterceptor<Cosmos_Staking_V1beta1_QueryHistoricalInfoRequest, Cosmos_Staking_V1beta1_QueryHistoricalInfoResponse>]

  /// - Returns: Interceptors to use when handling 'validatorOutstandingReward'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeValidatorOutstandingRewardInterceptors() -> [ServerInterceptor<Confio_Poe_V1beta1_QueryValidatorOutstandingRewardRequest, Confio_Poe_V1beta1_QueryValidatorOutstandingRewardResponse>]
}
